.globl	gcd

# int gcd(int a, int b)
gcd:
	pushl	%ebp		# new stack frame
	movl	%esp,%ebp
	pushl	%ebx		# save regs
	pushl	%edx

	movl	0x8(%ebp),%eax	# int a
	movl	0xc(%ebp),%ebx	# int b
loop:
	cmpl	%ebx,%eax
	ja	noswap
	xchgl	%eax,%ebx	# swap a and b if a<b
noswap:
	xorl	%edx,%edx	# edx=0
	div	%ebx		# eax=eax/ebx
	movl	%edx,%eax
	testl	%edx,%edx
	jnz	loop		# break if edx==0

	xchgl	%eax,%ebx	# get last nonzero remainder
	popl	%edx		# restore regs
	popl	%ebx
	movl	%ebp,%esp	# restore stack frame
	popl	%ebp
	ret
